////////////////////////////////////////////////////////
//
// SourceMod Script
//
// DoD WeaponDamageMultiplier
//
// Developed by FeuerSturm for the Realism Community!
//
////////////////////////////////////////////////////////
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name = "DoD WeaponDamageMultiplier",
	author = "FeuerSturm",
	description = "Change each weapon's damage on the fly!",
	version = "1.0",
	url = "http://www.dodsourceplugins.net"
}

#define MAXWEAPONS		14
#define MAXMELEE		4
#define MAXPROJECTILE	6

new String:g_Bullet[MAXWEAPONS][] =
{
	"weapon_colt", "weapon_p38", "weapon_m1carbine", "weapon_c96", "weapon_garand",
	"weapon_k98", "weapon_thompson", "weapon_mp40", "weapon_bar", "weapon_mp44",
	"weapon_spring", "weapon_k98_scoped", "weapon_30cal", "weapon_mg42"
}

new String:g_Melee[MAXMELEE][] =
{
	"punch_amerknife", "punch_spade", "punch_thompson", "punch_mp40"
}

new String:g_Projectile[MAXPROJECTILE][] =
{
	"grenade_frag_us", "grenade_frag_ger", "grenade_riflegren_us", "grenade_riflegren_ger",
	"rocket_bazooka", "rocket_pschreck"
}

new Handle:DoDWDM = INVALID_HANDLE

public OnPluginStart()
{
	decl String:ConVarName[256]
	decl String:ConVarDescription[256]
	for(new weapon = 0; weapon < MAXWEAPONS; weapon++)
	{
		Format(ConVarName, sizeof(ConVarName), "dod_wdm_%s", g_Bullet[weapon])
		Format(ConVarDescription, sizeof(ConVarDescription), "<#.#> set DamageMultiplier per Hit for %s! 1.0 = no change!", g_Bullet[weapon])
		CreateConVar(ConVarName, "1.0", ConVarDescription, FCVAR_PLUGIN, true, 0.0, false)
	}
	for(new melee = 0; melee < MAXMELEE; melee++)
	{
		Format(ConVarName, sizeof(ConVarName), "dod_wdm_%s", g_Melee[melee])
		Format(ConVarDescription, sizeof(ConVarDescription), "<#.#> set DamageMultiplier per Hit for %s! 1.0 = no change!", g_Melee[melee])
		CreateConVar(ConVarName, "1.0", ConVarDescription, FCVAR_PLUGIN, true, 0.0, false)
	}
	for(new projectile = 0; projectile < MAXPROJECTILE; projectile++)
	{
		Format(ConVarName, sizeof(ConVarName), "dod_wdm_%s", g_Projectile[projectile])
		Format(ConVarDescription, sizeof(ConVarDescription), "<#.#> set DamageMultiplier per Hit for %s! 1.0 = no change!", g_Projectile[projectile])
		CreateConVar(ConVarName, "1.0", ConVarDescription, FCVAR_PLUGIN, true, 0.0, false)
	}
	DoDWDM = CreateConVar("dod_weapondamagemultiplier", "1", "<1/0> enable/disable WeaponDamageMultiplier!", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	AutoExecConfig(true, "dod_weapondamagemultiplier", "dod_weapondamagemultiplier")
}

public OnClientPutInServer(client)
{
    SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage)
}

public Action:OnTakeDamage(victim, &attacker, &inflictor, &Float:damage, &damagetype)
{
	if(GetConVarInt(DoDWDM) == 0 || victim < 1 || victim > MaxClients || victim < 1 || victim > MaxClients || !IsClientInGame(victim))
	{
		return Plugin_Continue
	}
	if(inflictor > MaxClients && IsValidEdict(inflictor))
	{
		decl String:Projectile[32]
		GetEdictClassname(inflictor, Projectile, sizeof(Projectile))
		new WeaponID = -1
		for(new i = 0; i < MAXPROJECTILE; i++)
		{
			if(strcmp(Projectile, g_Projectile[i]) == 0)
			{
				WeaponID = i
			}
		}
		if(WeaponID != -1)
		{
			decl String:DamageConVar[256]
			Format(DamageConVar, sizeof(DamageConVar), "dod_wdm_%s", Projectile)
			new Handle:Cvar = FindConVar(DamageConVar)
			if(Cvar == INVALID_HANDLE)
			{
				return Plugin_Continue
			}
			new Float:Multiplier = GetConVarFloat(Cvar)
			if(Multiplier == 1.0)
			{
				return Plugin_Continue
			}
			damage *= Multiplier
			return Plugin_Changed
		}
		return Plugin_Continue
	}
	if(damagetype & DMG_CLUB && damagetype & DMG_NEVERGIB)
	{
		decl String:Melee[32]
		GetClientWeapon(attacker, Melee, sizeof(Melee))
		new WeaponID = -1
		for(new i = 0; i < MAXMELEE; i++)
		{
			decl String:MeleeWeapon[32]
			strcopy(MeleeWeapon, sizeof(MeleeWeapon), g_Melee[i])
			ReplaceString(MeleeWeapon, sizeof(MeleeWeapon), "punch", "weapon", true)
			if(strcmp(Melee, MeleeWeapon) == 0)
			{
				WeaponID = i
			}
		}
		if(WeaponID != -1)
		{
			decl String:DamageConVar[256]
			Format(DamageConVar, sizeof(DamageConVar), "dod_wdm_%s", g_Melee[WeaponID])
			new Handle:Cvar = FindConVar(DamageConVar)
			if(Cvar == INVALID_HANDLE)
			{
				return Plugin_Continue
			}
			new Float:Multiplier = GetConVarFloat(Cvar)
			if(Multiplier == 1.0)
			{
				return Plugin_Continue
			}
			damage *= Multiplier
			return Plugin_Changed
		}
		return Plugin_Continue
	}	
	if(damagetype & DMG_BULLET)
	{
		decl String:Weapon[32]
		GetClientWeapon(attacker, Weapon, sizeof(Weapon))
		new WeaponID = -1
		for(new i = 0; i < MAXWEAPONS; i++)
		{
			if(strcmp(Weapon, g_Bullet[i]) == 0)
			{
				WeaponID = i
			}
		}
		if(WeaponID != -1)
		{
			decl String:DamageConVar[256]
			Format(DamageConVar, sizeof(DamageConVar), "dod_wdm_%s", Weapon)
			new Handle:Cvar = FindConVar(DamageConVar)
			if(Cvar == INVALID_HANDLE)
			{
				return Plugin_Continue
			}
			new Float:Multiplier = GetConVarFloat(Cvar)
			if(Multiplier == 1.0)
			{
				return Plugin_Continue
			}
			damage *= Multiplier
			return Plugin_Changed
		}
		return Plugin_Continue
	}
	return Plugin_Continue
}